var NetlessAppPDFjs = (function (exports) {
  'use strict';

  var __defProp = Object.defineProperty;
  var __getOwnPropSymbols = Object.getOwnPropertySymbols;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __propIsEnum = Object.prototype.propertyIsEnumerable;
  var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
  var __spreadValues = (a, b) => {
    for (var prop in b || (b = {}))
      if (__hasOwnProp.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    if (__getOwnPropSymbols)
      for (var prop of __getOwnPropSymbols(b)) {
        if (__propIsEnum.call(b, prop))
          __defNormalProp(a, prop, b[prop]);
      }
    return a;
  };
  var __publicField = (obj, key, value) => {
    __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
    return value;
  };

  // node_modules/.pnpm/@wopjs+disposable@0.1.5/node_modules/@wopjs/disposable/dist/index.mjs
  var isAbortable = (disposable) => disposable && disposable.abortable;
  var dispose = (disposable) => {
    try {
      if (disposable) {
        if (disposable.dispose) {
          disposable.dispose();
        } else if (disposable.constructor && disposable.call && disposable.apply) {
          disposable();
        }
      }
    } catch (e) {
      console.error(e);
    }
  };
  var methods = {
    size() {
      return this._d.size;
    },
    has(disposable) {
      return this._d.has(disposable);
    },
    add(disposable) {
      const disposables = Array.isArray(disposable) ? disposable : [disposable];
      for (const disposable2 of disposables) {
        if (!this._d.has(disposable2)) {
          this._d.add(disposable2);
          if (isAbortable(disposable2)) {
            disposable2.abortable(() => this.remove(disposable2));
          }
        }
      }
      return disposable;
    },
    make(executor) {
      const disposable = executor();
      if (disposable) {
        return this.add(disposable);
      }
    },
    remove(disposable) {
      return this._d.delete(disposable);
    },
    flush(disposable) {
      if (disposable) {
        if (this.remove(disposable)) {
          dispose(disposable);
        }
      } else {
        this.dispose();
      }
    }
  };
  var disposableStore = (disposables) => {
    const disposableStore2 = () => {
      disposableStore2._d.forEach(dispose);
      disposableStore2._d.clear();
    };
    disposableStore2._d = /* @__PURE__ */ new Set();
    disposableStore2.dispose = disposableStore2;
    const store = Object.assign(disposableStore2, methods);
    if (disposables) {
      store.add(disposables);
    }
    return store;
  };

  // node_modules/.pnpm/@wopjs+dom@0.1.3/node_modules/@wopjs/dom/dist/index.js
  function addEventListener(target, type, listener, options) {
    target.addEventListener(type, listener, options);
    return () => target.removeEventListener(type, listener, options);
  }
  var listen = addEventListener;

  // node_modules/.pnpm/@wopjs+async-seq@0.0.1/node_modules/@wopjs/async-seq/dist/index.mjs
  var tryCall = async (fn) => {
    try {
      return await fn();
    } catch (e) {
      console.error(e);
    }
  };
  var isAbortable2 = (disposable) => disposable && disposable.abortable;
  var AsyncSeq = class {
    constructor(options) {
      __publicField(this, "_w");
      __publicField(this, "_h");
      __publicField(this, "_f");
      __publicField(this, "_p");
      __publicField(this, "_d");
      var _a, _b;
      this._f = [];
      this._w = (_a = options == null ? void 0 : options.window) != null ? _a : Infinity;
      this._h = (_b = options == null ? void 0 : options.dropHead) != null ? _b : false;
    }
    /**
     * Is sequence running.
     */
    get running() {
      return !!this._p;
    }
    /**
     * Size of pending tasks in the sequence.
     */
    get size() {
      return this._f.length;
    }
    /**
     * Is sequence full.
     */
    get full() {
      return this.size >= this._w;
    }
    /**
     * Add task executors to the sequence.
     * @param fns Task executors. Optionally returns a disposer function that cleans up side effects.
     */
    async add(...fns) {
      this._f.push(...fns);
      const diff = this._f.length - this._w;
      if (diff >= 0) {
        this._f.splice(this._h ? 0 : this._w, diff);
      }
      if (!this._p) {
        this._p = this._r();
      }
      await this._p;
    }
    /**
     * Dispose the sequence.
     */
    async dispose() {
      this._f.length = 0;
      await this._p;
      if (this._d) {
        await tryCall(this._d);
      }
    }
    async _r() {
      let fn;
      while (fn = this._f[0]) {
        if (this._d) {
          await tryCall(this._d);
        }
        const disposer = await tryCall(fn);
        this._d = disposer;
        if (isAbortable2(disposer)) {
          disposer.abortable(() => {
            if (this._d === disposer) {
              this._d = null;
            }
          });
        }
        this._f.shift();
      }
      this._p = null;
    }
  };
  var seq = (options) => new AsyncSeq(options);

  // src/icons.ts
  function sidebarSVG(namespace) {
    const NS = "http://www.w3.org/2000/svg";
    const $svg = document.createElementNS(NS, "svg");
    $svg.setAttribute("class", `${namespace}-footer-icon-sidebar`);
    $svg.setAttribute("viewBox", "0 0 64 64");
    const $path = document.createElementNS(NS, "path");
    $path.setAttribute("fill", "currentColor");
    $path.setAttribute("d", "M50 8H14c-3.309 0-6 2.691-6 6v36c0 3.309 2.691 6 6 6h36c3.309 0 6-2.691 6-6V14c0-3.309-2.691-6-6-6zM12 50V14c0-1.103.897-2 2-2h8v40h-8c-1.103 0-2-.897-2-2zm40 0c0 1.103-.897 2-2 2H26V12h24c1.103 0 2 .897 2 2z");
    $svg.appendChild($path);
    return $svg;
  }
  function arrowLeftSVG(namespace) {
    const NS = "http://www.w3.org/2000/svg";
    const $svg = document.createElementNS(NS, "svg");
    $svg.setAttribute("class", `${namespace}-footer-icon-arrow-left`);
    $svg.setAttribute("viewBox", "0 0 500 500");
    const $path = document.createElementNS(NS, "path");
    $path.setAttribute("fill", "currentColor");
    $path.setAttribute("d", "M177.81 249.959L337.473 90.295c2.722-2.865 2.651-7.378-.143-10.1-2.793-2.65-7.163-2.65-9.956 0l-164.75 164.75c-2.793 2.793-2.793 7.306 0 10.1l164.75 164.75c2.865 2.722 7.378 2.65 10.099-.143 2.651-2.794 2.651-7.163 0-9.957L177.809 249.959z");
    $svg.appendChild($path);
    return $svg;
  }
  function arrowRightSVG(namespace) {
    const NS = "http://www.w3.org/2000/svg";
    const $svg = document.createElementNS(NS, "svg");
    $svg.setAttribute("class", `${namespace}-footer-icon-arrow-right`);
    $svg.setAttribute("viewBox", "0 0 500 500");
    const $path = document.createElementNS(NS, "path");
    $path.setAttribute("fill", "currentColor");
    $path.setAttribute("d", "M322.19 250.041L162.527 409.705c-2.722 2.865-2.651 7.378.143 10.1 2.793 2.65 7.163 2.65 9.956 0l164.75-164.75c2.793-2.793 2.793-7.306 0-10.1l-164.75-164.75c-2.865-2.722-7.378-2.65-10.099.143-2.651 2.794-2.651 7.163 0 9.957l159.664 159.736z");
    $svg.appendChild($path);
    return $svg;
  }

  // src/pdf-viewer.ts
  function inferWorkerSrc(pdfjsLib) {
    let index = pdfjsLib.lastIndexOf("/pdf.");
    if (index >= 0) {
      return pdfjsLib.slice(0, index) + "/pdf.worker." + pdfjsLib.slice(index + 5);
    }
    return "https://cdn.jsdelivr.net/npm/pdfjs-dist@latest/build/pdf.worker.min.mjs";
  }
  function load(lib) {
    return Promise.resolve(globalThis.pdfjsLib || import(
      /* @vite-ignore */
      lib
    ));
  }
  function calcTransform(hidpi) {
    if (hidpi) {
      let base = globalThis.devicePixelRatio || 1;
      let scale = typeof hidpi === "number" ? Math.min(hidpi, base) : base;
      if (scale > 0 && scale !== 1)
        return [scale, 0, 0, scale, 0, 0];
    }
  }
  function block() {
    let resolve;
    let promise = new Promise((r) => {
      resolve = r;
    });
    return [promise, resolve];
  }
  var PreviewLazyLoad = class {
    constructor(options) {
      this.options = options;
      this.observer = new IntersectionObserver(this.handler.bind(this), { root: options.container });
      const elements = this.options.container.querySelectorAll(this.options.elements_selector);
      elements.forEach((element) => this.observer.observe(element));
    }
    handler(entries) {
      entries.forEach((entry) => {
        if (entry.isIntersecting || entry.intersectionRatio > 0)
          this.options.touch(entry.target);
      });
    }
    destroy() {
      this.observer.disconnect();
    }
  };
  var PDFViewer = class {
    constructor(options) {
      this.namespace = "netless-app-pdfjs";
      this.dispose = disposableStore();
      this.rendering = seq();
      this.destroyed = false;
      this.getDocumentTask = null;
      this.pdf = null;
      this.lastRenderingTask = null;
      this.pdfjs = null;
      this.showPreview = false;
      this.previewLazyLoad = null;
      this.touched = /* @__PURE__ */ Object.create(null);
      this.pageIndex = 0;
      const pdfjsLib = options.pdfjsLib || "https://cdn.jsdelivr.net/npm/pdfjs-dist@latest/build/pdf.min.mjs";
      const workerSrc = options.workerSrc || inferWorkerSrc(pdfjsLib);
      this.options = Object.assign(
        { scale: 1.5, previewScale: 0.2, hidpi: true, readonly: false },
        options,
        { pdfjsLib, workerSrc }
      );
      this.scale = this.options.scale;
      this.readonly = this.options.readonly;
      const [ready, resolve] = block();
      this.ready = ready;
      this.pdfjsLib = load(this.options.pdfjsLib);
      this.pdfjsLib.then((pdfjs) => {
        if (this.destroyed)
          return;
        this.pdfjs = pdfjs;
        pdfjs.GlobalWorkerOptions.workerSrc = this.options.workerSrc;
        this.getDocumentTask = pdfjs.getDocument(this.options.src);
        this.getDocumentTask.promise.then(this.onLoad.bind(this, resolve), this.onError.bind(this));
        this.contentDOM.dataset.pdfjs = [pdfjs.version, pdfjs.build].join(" ");
      });
      this.pdfjsLib.catch(this.onError.bind(this));
      this.dispose.add(() => {
        var _a, _b, _c;
        this.destroyed = true;
        (_a = this.previewLazyLoad) == null ? void 0 : _a.destroy();
        this.previewLazyLoad = null;
        (_b = this.getDocumentTask) == null ? void 0 : _b.destroy();
        this.getDocumentTask = null;
        (_c = this.lastRenderingTask) == null ? void 0 : _c.cancel();
        this.lastRenderingTask = null;
      });
      this.dom = document.createElement("div");
      this.dom.className = this.namespace;
      this.contentDOM = document.createElement("div");
      this.contentDOM.className = this.c("content");
      const previewMask = this.contentDOM.appendChild(document.createElement("div"));
      previewMask.className = this.c("preview-mask");
      this.dispose.add(listen(previewMask, "click", (ev) => {
        if (this.readonly)
          return;
        if (ev.target == previewMask) {
          this.togglePreview(false);
        }
      }));
      this.previewDOM = document.createElement("div");
      this.previewDOM.className = this.c("preview");
      this.previewDOM.classList.add("tele-fancy-scrollbar");
      this.contentDOM.appendChild(this.previewDOM);
      this.dispose.add(listen(this.previewDOM, "click", (ev) => {
        var _a;
        const pageIndex = (_a = ev.target.dataset) == null ? void 0 : _a.pageIndex;
        if (pageIndex) {
          ev.preventDefault();
          ev.stopPropagation();
          ev.stopImmediatePropagation();
          this.onNewPageIndex(Number(pageIndex), "preview");
          this.togglePreview(false);
        }
      }));
      ready.then(() => {
        if (this.destroyed)
          return;
        this.makePreview();
      });
      this.pageDOM = document.createElement("div");
      this.pageDOM.className = this.c("page");
      this.canvas = document.createElement("canvas");
      this.whiteboardDOM = document.createElement("div");
      this.whiteboardDOM.className = this.c("wb-view");
      this.footerDOM = document.createElement("div");
      this.footerDOM.className = this.c("footer");
      this.totalPageDOM = document.createElement("span");
      this.totalPageDOM.className = this.c("total-page");
      this.pageNumberInputDOM = document.createElement("input");
      this.pageNumberInputDOM.className = this.c("page-number-input");
      this.contentDOM.classList.toggle(this.c("readonly"), this.readonly);
      this.dom.appendChild(this.contentDOM);
      this.pageDOM.appendChild(this.canvas);
      this.contentDOM.appendChild(this.pageDOM);
      this.contentDOM.appendChild(this.whiteboardDOM);
      this.footerDOM.classList.toggle(this.c("readonly"), this.readonly);
      this.dom.appendChild(this.footerDOM);
      const btnSidebar = document.createElement("button");
      btnSidebar.className = `${this.c("footer-btn")} ${this.c("btn-sidebar")}`;
      btnSidebar.appendChild(sidebarSVG(this.namespace));
      this.footerDOM.appendChild(btnSidebar);
      this.dispose.add(listen(btnSidebar, "click", () => {
        if (this.readonly)
          return;
        this.togglePreview();
      }));
      const pageJumps = document.createElement("div");
      pageJumps.className = this.c("page-jumps");
      this.footerDOM.appendChild(pageJumps);
      const btnPageBack = document.createElement("button");
      btnPageBack.className = `${this.c("footer-btn")} ${this.c("btn-page-back")}`;
      btnPageBack.appendChild(arrowLeftSVG(this.namespace));
      pageJumps.appendChild(btnPageBack);
      this.dispose.add(listen(btnPageBack, "click", () => {
        if (this.readonly)
          return;
        if (this.pageIndex > 0)
          this.onNewPageIndex(this.pageIndex - 1, "navigation");
      }));
      const btnPageNext = document.createElement("button");
      btnPageNext.className = `${this.c("footer-btn")} ${this.c("btn-page-next")}`;
      btnPageNext.appendChild(arrowRightSVG(this.namespace));
      pageJumps.appendChild(btnPageNext);
      this.dispose.add(listen(btnPageNext, "click", () => {
        var _a;
        if (this.readonly)
          return;
        const pagesLength = ((_a = this.pdf) == null ? void 0 : _a.numPages) || 0;
        if (this.pageIndex < pagesLength - 1)
          this.onNewPageIndex(this.pageIndex + 1, "navigation");
      }));
      const pageNumber = document.createElement("div");
      pageNumber.className = this.c("page-number");
      this.footerDOM.appendChild(pageNumber);
      pageNumber.appendChild(this.pageNumberInputDOM);
      this.pageNumberInputDOM.value = String(this.pageIndex + 1);
      this.dispose.add(listen(this.pageNumberInputDOM, "focus", () => {
        if (this.readonly)
          return;
        this.pageNumberInputDOM.select();
      }));
      this.dispose.add(listen(this.pageNumberInputDOM, "change", () => {
        if (this.readonly)
          return;
        if (this.pageNumberInputDOM.value) {
          this.onNewPageIndex(Number(this.pageNumberInputDOM.value) - 1, "input");
        }
      }));
      this.totalPageDOM.textContent = "\u2026";
      pageNumber.appendChild(this.totalPageDOM);
      this.dispose.add(listen(window, "keydown", (ev) => {
        if (this.readonly || this.isEditable(ev.target))
          return;
        if (ev.key == "ArrowUp" || ev.key == "ArrowLeft")
          this.onNewPageIndex(this.pageIndex - 1, "keydown");
        else if (ev.key == "ArrowDown" || ev.key == "ArrowRight")
          this.onNewPageIndex(this.pageIndex + 1, "keydown");
      }));
      ready.then(this.refresh.bind(this));
    }
    setDOM(dom) {
      if (this.dom == dom)
        return;
      dom.appendChild(this.contentDOM);
      dom.appendChild(this.footerDOM);
      this.dom = dom;
    }
    setReadonly(readonly) {
      if (this.readonly == readonly)
        return;
      this.contentDOM.classList.toggle(this.c("readonly"), readonly);
      this.footerDOM.classList.toggle(this.c("readonly"), readonly);
      this.pageNumberInputDOM.disabled = readonly;
      this.readonly = readonly;
    }
    setPageIndex(pageIndex) {
      if (Number.isSafeInteger(pageIndex)) {
        this.pageIndex = pageIndex;
        this.pageNumberInputDOM.value = String(pageIndex + 1);
        this.refresh();
      }
    }
    onNewPageIndex(index, _origin) {
      var _a;
      if (0 <= index && index < (((_a = this.pdf) == null ? void 0 : _a.numPages) || 0)) {
        this.setPageIndex(index);
      }
    }
    page() {
      var _a;
      return (_a = this.pdf) == null ? void 0 : _a.getPage(this.pageIndex + 1);
    }
    size() {
      const viewport = this.canvas.dataset.viewport || "0,0";
      const [width = 0, height = 0] = viewport.split(",").map((e) => Number(e));
      return { width, height };
    }
    numPages() {
      var _a;
      return ((_a = this.pdf) == null ? void 0 : _a.numPages) || 0;
    }
    togglePreview(show) {
      this.showPreview = show != null ? show : !this.showPreview;
      this.contentDOM.classList.toggle(this.c("preview-active"), this.showPreview);
      if (this.showPreview) {
        const previewPageDOM = this.previewDOM.querySelector("." + this.c(`preview-page-${this.pageIndex}`));
        if (previewPageDOM) {
          this.previewLazyLoad || (this.previewLazyLoad = new PreviewLazyLoad({
            container: this.previewDOM,
            elements_selector: `.${this.c("preview-page>canvas")}`,
            touch: async (canvas) => {
              const pageNumber = +(canvas.dataset.pageIndex || 0) + 1;
              if (this.touched[pageNumber])
                return;
              this.touched[pageNumber] = true;
              await this.render(pageNumber, canvas, this.scale * this.options.previewScale);
            }
          }));
          this.previewDOM.scrollTo({ top: previewPageDOM.offsetTop - 16 });
        }
      }
    }
    refresh() {
      var _a;
      if (this.destroyed)
        return;
      const page = this.page();
      if (!page) {
        const context = this.canvas.getContext("2d");
        context && context.clearRect(0, 0, this.canvas.width, this.canvas.height);
        return;
      }
      const pagesLength = ((_a = this.pdf) == null ? void 0 : _a.numPages) || 0;
      this.totalPageDOM.textContent = pagesLength > 0 ? ` / ${pagesLength}` : "\u2026";
      this.onRenderStart();
      this.render(this.pageIndex + 1, this.canvas).then(this.onRenderEnd.bind(this)).catch(this.onRenderError.bind(this));
    }
    onLoad(done, pdf) {
      if (this.destroyed)
        return;
      this.pdf = pdf;
      this.getDocumentTask = null;
      if (this.options.maxSize) {
        let maxSize = this.options.maxSize;
        let minScale = this.scale;
        let promises = [];
        for (let i = 1; i <= pdf.numPages; i++) {
          promises.push(pdf.getPage(i).then((page) => {
            let { width, height } = page.getViewport({ scale: 1 });
            if (width === 0 || height === 0)
              return;
            minScale = Math.min(minScale, maxSize.width / width);
            minScale = Math.min(minScale, maxSize.height / height);
          }));
        }
        Promise.allSettled(promises).then(() => {
          this.scale = minScale;
          done();
        });
      } else {
        done();
      }
    }
    // Either the PDF.js lib or getDocument() failed to load.
    onError(reason) {
      console.error(reason);
      this.dispose();
    }
    onRenderStart() {
    }
    onRenderEnd() {
    }
    onRenderError(reason) {
      if (("" + reason).includes("RenderingCancelledException"))
        return;
      console.warn(reason);
    }
    async makePreview() {
      await this.ready;
      let pdf = this.pdf;
      if (!pdf)
        throw new Error("PDF not loaded.");
      const c_previewPage = this.c("preview-page");
      const c_previewPageName = this.c("preview-page-name");
      for (let index = 0; index < pdf.numPages; index++) {
        const page = await pdf.getPage(index + 1);
        const viewport = page.getViewport({ scale: this.scale * this.options.previewScale });
        const previewPage = document.createElement("a");
        previewPage.className = `${c_previewPage} ${this.c(`preview-page-${index}`)}`;
        previewPage.setAttribute("href", "#");
        previewPage.dataset.pageIndex = String(index);
        const canvas = document.createElement("canvas");
        const transform = calcTransform(this.options.hidpi);
        const ratio = transform ? transform[0] : 1;
        canvas.width = viewport.width * ratio;
        canvas.height = viewport.height * ratio;
        canvas.dataset.pageIndex = String(index);
        const name = document.createElement("span");
        name.className = c_previewPageName;
        name.textContent = String(index + 1);
        name.dataset.pageIndex = String(index);
        previewPage.appendChild(canvas);
        previewPage.appendChild(name);
        this.previewDOM.appendChild(previewPage);
      }
    }
    async render(pageNumber, canvas = document.createElement("canvas"), scale = this.scale) {
      return this.rendering.add(() => this.render_(pageNumber, canvas, scale));
    }
    async render_(pageNumber, canvas = document.createElement("canvas"), scale = this.scale) {
      var _a;
      await this.ready;
      let pdf = this.pdf;
      if (!pdf)
        throw new Error("PDF not loaded.");
      if (!(1 <= pageNumber && pageNumber <= pdf.numPages))
        throw new Error(`Invalid page number, expecting 1..${pdf.numPages}, got ${pageNumber}.`);
      let page = await pdf.getPage(pageNumber);
      let viewport = page.getViewport({ scale });
      let transform = calcTransform(this.options.hidpi);
      let ratio = transform ? transform[0] : 1;
      canvas.width = viewport.width * ratio;
      canvas.height = viewport.height * ratio;
      canvas.dataset.viewport = [viewport.width, viewport.height].join();
      let context = canvas.getContext("2d");
      if (!context)
        throw new Error("Failed to create canvas 2d context.");
      (_a = this.lastRenderingTask) == null ? void 0 : _a.cancel();
      this.lastRenderingTask = page.render({ canvasContext: context, viewport, transform });
      await this.lastRenderingTask.promise;
      this.lastRenderingTask = null;
    }
    c(className) {
      return `${this.namespace}-${className}`;
    }
    isEditable(el) {
      if (!el)
        return false;
      const { tagName } = el;
      return tagName === "INPUT" || tagName === "TEXTAREA" || tagName === "SELECT";
    }
  };

  // src/style.scss?inline
  var style_default = ".netless-app-pdfjs{height:100%;display:flex;flex-flow:column nowrap}.netless-app-pdfjs-content{position:relative;height:100%;overflow:hidden}.netless-app-pdfjs-preview-mask{display:none;position:absolute;z-index:200;top:0;left:0;width:100%;height:100%}.netless-app-pdfjs-preview{display:flex;flex-direction:column;align-items:center;position:absolute;z-index:300;top:0;left:0;width:33%;max-width:200px;height:100%;padding-top:10px;transform:translate(-100%);background:#ededf0e6;box-shadow:inset -1px 0 #0000001c;transition:transform .4s;overflow:auto;overflow-y:scroll}.netless-app-pdfjs-preview-active .netless-app-pdfjs-preview-mask{display:block}.netless-app-pdfjs-preview-active .netless-app-pdfjs-preview{transform:translate(0)}.netless-app-pdfjs-preview-page{position:relative;display:block;width:55%;margin-bottom:10px;font-size:0;color:#0000;outline:none;border:7px solid rgba(0,0,0,0);border-radius:4px;transition:border-color .3s;user-select:none}.netless-app-pdfjs-preview-page:hover,.netless-app-pdfjs-preview-page.netless-app-pdfjs-preview-page-active{border-color:#444e601a}.netless-app-pdfjs-preview-page>canvas{width:100%;height:auto;box-sizing:border-box;border:1px solid rgba(0,0,0,.5);border-radius:1px;background-color:#fff;box-shadow:0 2px 8px #0000004d}.netless-app-pdfjs-preview-page-name{position:absolute;top:1px;left:-10px;transform:translate(-100%);text-align:right;font-size:12px;color:#5f5f5f;user-select:none}.netless-app-pdfjs-footer{box-sizing:border-box;height:26px;display:flex;align-items:center;padding:0 16px;border-top:1px solid #eeeef7;color:#191919;position:relative}.netless-app-pdfjs-float-footer{width:100%;min-height:26px;position:absolute;left:0;bottom:0;z-index:2000;background:#f9f9fce6;transition:opacity .4s}.netless-app-pdfjs-footer-btn{box-sizing:border-box;width:26px;height:26px;font-size:0;margin:0;padding:3px;border:none;border-radius:1px;outline:none;color:currentColor;background:#0000;transition:background .4s;cursor:pointer;user-select:none;-webkit-tap-highlight-color:rgba(0,0,0,0)}.netless-app-pdfjs-footer-btn:hover{background:#ededf0e6}@media (hover: none){.netless-app-pdfjs-footer-btn:hover{background:#0000!important}}.netless-app-pdfjs-footer-btn>svg{width:100%;height:100%}.netless-app-pdfjs-footer-btn>svg:nth-of-type(2){display:none}.netless-app-pdfjs-footer-btn.netless-app-pdfjs-btn-sidebar{position:relative;z-index:1}.netless-app-pdfjs-footer-btn.netless-app-pdfjs-footer-btn-playing>svg:nth-of-type(1){display:none}.netless-app-pdfjs-footer-btn.netless-app-pdfjs-footer-btn-playing>svg:nth-of-type(2){display:initial}.netless-app-pdfjs-footer-btn~.netless-app-pdfjs-footer-btn{margin-left:15px}.netless-app-pdfjs-page-jumps{position:absolute;inset:0;flex:1;display:flex;justify-content:center;align-items:center}.netless-app-pdfjs-page-number{position:absolute;inset:0 16px 0 auto;font-size:13px;display:inline-flex;align-items:center}.netless-app-pdfjs-page-number-input{border:none;outline:none;width:3em;margin:0;padding:0 2px;text-align:right;font-size:13px;line-height:1;font-weight:400;font-family:inherit;border-radius:2px;color:currentColor;background:#0000;transition:background .4s;user-select:text;-webkit-tap-highlight-color:rgba(0,0,0,0)}.netless-app-pdfjs-page-number-input:not(:disabled):hover,.netless-app-pdfjs-page-number-input:not(:disabled):focus,.netless-app-pdfjs-page-number-input:not(:disabled):active{background:#fff;box-shadow:#63636333 0 2px 8px}.netless-app-pdfjs-readonly .netless-app-pdfjs-footer-btn{display:none}.netless-app-pdfjs-wb-view{position:absolute;top:0;left:0;width:100%;height:100%;z-index:100;overflow:hidden}.netless-app-pdfjs-page{width:100%;height:100%;display:flex;align-items:center;justify-content:center}.netless-app-pdfjs-page>canvas{max-width:100%;max-height:100%;object-fit:contain}.telebox-color-scheme-dark .netless-app-pdfjs-page-number-input{color:#a6a6a8}.telebox-color-scheme-dark .netless-app-pdfjs-page-number-input:active,.telebox-color-scheme-dark .netless-app-pdfjs-page-number-input:focus,.telebox-color-scheme-dark .netless-app-pdfjs-page-number-input:hover{color:#222}.telebox-color-scheme-dark .netless-app-pdfjs-footer{color:#a6a6a8;background:#2d2d33;border-top:none}.telebox-color-scheme-dark .netless-app-pdfjs-footer-btn:hover{background:#212126}.telebox-color-scheme-dark .netless-app-pdfjs-preview{background:#323232e6}";

  // src/app-pdfjs.ts
  var createLogger = (room) => {
    if (room && room.logger) {
      return (...args) => room.logger.info(...args);
    } else {
      return (...args) => console.log(...args);
    }
  };
  var DefaultMaxCameraScale = 3;
  var AppPDFViewer = class extends PDFViewer {
    constructor(options) {
      super(options);
      this.jumpPage = options.jumpPage;
    }
    onNewPageIndex(index, origin) {
      if (origin === "keydown" && this.box && !this.box.focus)
        return;
      if (this.log)
        this.log(`[PDFjs]: user navigate to ${index + 1} (${origin})`);
      const length = this.numPages();
      if (0 <= index && index < length) {
        this.jumpPage(index);
      } else if (length === 0) {
        console.warn(`[PDFjs]: PDF is not ready, skip navigation`);
      } else {
        console.warn(`[PDFjs]: page index ${index} out of bounds [0, ${length - 1}]`);
      }
    }
    onRenderEnd() {
      super.onRenderEnd();
      this.scaleDocsToFit && this.scaleDocsToFit();
      this.syncPDFView && this.syncPDFView();
    }
    onRenderError(reason) {
      super.onRenderError(reason);
      this.log && this.log(`[PDFjs]: render error ${reason}`);
    }
  };
  var createPDFViewer = (box, src, jumpPage, page$$, options) => {
    box.mountStyles(style_default);
    const app = new AppPDFViewer(__spreadValues({ src, readonly: box.readonly, jumpPage }, options));
    app.box = box;
    box.mountContent(app.contentDOM);
    box.mountFooter(app.footerDOM);
    app.setPageIndex(page$$.state.index);
    app.dispose.add(page$$.addStateChangedListener(() => {
      app.setPageIndex(page$$.state.index);
    }));
    return app;
  };
  var NetlessAppPDFjs = {
    kind: "PDFjs",
    setup(context) {
      var _a, _b;
      const view = context.getView();
      if (!view)
        throw new Error("[PDFjs]: no whiteboard view, make sure you have added options.scenePath in addApp()");
      const src = context.storage.state.src;
      if (!src)
        throw new Error("[PDFjs]: no PDF file URL, make sure you have set 'src' in addApp({ attributes: { src } })");
      const scenePath = context.getInitScenePath();
      const options = context.getAppOptions() || {};
      let maxCameraScale = (_a = options.maxCameraScale) != null ? _a : DefaultMaxCameraScale;
      if (!(Number.isFinite(maxCameraScale) && maxCameraScale > 0)) {
        console.warn(`[PDFjs] maxCameraScale should be a positive number, got ${options.maxCameraScale}`);
        maxCameraScale = DefaultMaxCameraScale;
      }
      const log = options.log || createLogger(context.getRoom());
      log(`[PDFjs]: new ${context.appId} ${src}`);
      const dispose2 = disposableStore();
      dispose2.add(() => log(`[PDFjs]: dispose ${context.appId}`));
      const page$$ = context.createStorage("page", { index: 0 });
      const view$$ = context.createStorage("view", { uid: "", originX: 0, originY: 0, width: 0, height: 0 });
      let lastIndex = -1;
      const syncPage = async (index) => {
        if (lastIndex !== index) {
          lastIndex = index;
          context.dispatchAppEvent("pageStateChange", { index, length: app.numPages() });
        }
        if (!context.getIsWritable())
          return;
        const scenes = context.getDisplayer().entireScenes()[scenePath];
        if (!scenes)
          return;
        const name = String(index + 1);
        if (!scenes.some((scene) => scene.name === name)) {
          await context.addPage({ scene: { name } });
        }
        await context.setScenePath(`${scenePath}/${name}`);
      };
      const jumpPage = (index) => {
        if (!context.getIsWritable()) {
          console.warn("[PDFjs]: no permission, make sure you have test room.isWritable");
          return false;
        }
        const pagesLength = app.numPages();
        if (!(0 <= index && index < pagesLength)) {
          if (pagesLength === 0) {
            console.warn(`[PDFjs]: PDF is not ready, skip page ${index + 1}`);
          } else {
            console.warn(`[PDFjs]: page ${index + 1} out of bounds [1, ${pagesLength}]`);
          }
          return false;
        }
        const scenes = context.getDisplayer().entireScenes()[scenePath];
        if (!scenes) {
          console.warn(`[PDFjs]: no scenes found at ${scenePath}, make sure you have added options.scenePath in addApp()`);
          return false;
        }
        const name = String(index + 1);
        if (!scenes.some((scene) => scene.name === name)) {
          context.addPage({ scene: { name } });
        }
        page$$.setState({ index });
        return true;
      };
      const scaleDocsToFit = () => {
        const { width, height } = app.size();
        if (width && height) {
          view.moveCameraToContain({
            originX: -width / 2,
            originY: -height / 2,
            width,
            height,
            animationMode: "immediately"
          });
          const maxScale = view.camera.scale * (options.disableCameraTransform ? 1 : maxCameraScale);
          const minScale = view.camera.scale;
          view.setCameraBound({
            damping: 1,
            maxContentMode: () => maxScale,
            minContentMode: () => minScale,
            centerX: 0,
            centerY: 0,
            width,
            height
          });
          syncViewFromRemote(true);
        }
      };
      const me = ((_b = context.getRoom()) == null ? void 0 : _b.uid) || context.getDisplayer().observerId + "";
      let throttleSyncView = 0;
      const syncView = () => {
        if (throttleSyncView > 0)
          return;
        const { width, height } = app.size();
        if (width && height && context.getIsWritable()) {
          const { camera, size } = view;
          const fixedW = Math.min(size.width, size.height * width / height);
          const fixedH = Math.min(size.height, size.width * height / width);
          const w = fixedW / camera.scale;
          const h = fixedH / camera.scale;
          const x = camera.centerX - w / 2;
          const y = camera.centerY - h / 2;
          throttleSyncView = setTimeout(() => {
            throttleSyncView = 0;
            view$$.setState({ uid: me, originX: x, originY: y, width: w, height: h });
          }, 50);
        }
      };
      dispose2.add(() => {
        clearTimeout(throttleSyncView);
        throttleSyncView = 0;
      });
      const syncViewFromRemote = (force = false, animate = false) => {
        const { uid, originX, originY, width, height } = view$$.state;
        if ((force || uid !== me) && width > 0 && height > 0) {
          view.moveCameraToContain({
            originX,
            originY,
            width,
            height,
            animationMode: animate ? "continuous" : "immediately"
          });
        }
      };
      let throttleSyncPDF = 0;
      const syncPDFView = () => {
        if (throttleSyncPDF > 0)
          return;
        throttleSyncPDF = requestAnimationFrame(() => {
          throttleSyncPDF = 0;
          const intrinsic = app.size();
          if (intrinsic.width > 0 && intrinsic.height > 0) {
            const camera = view.camera;
            const baseScale = Math.min(
              view.size.width / intrinsic.width,
              view.size.height / intrinsic.height
            );
            const scale = camera.scale / baseScale;
            const x = -camera.centerX * baseScale;
            const y = -camera.centerY * baseScale;
            app.canvas.style.position = "absolute";
            app.canvas.style.transform = `scale(${scale}) translate(${x}px, ${y}px)`;
          }
        });
      };
      dispose2.add(() => {
        cancelAnimationFrame(throttleSyncPDF);
        throttleSyncPDF = 0;
      });
      dispose2.make(() => {
        view.callbacks.on("onCameraUpdated", syncPDFView);
        return () => view.callbacks.off("onCameraUpdated", syncPDFView);
      });
      const box = context.getBox();
      const app = dispose2.add(createPDFViewer(box, src, jumpPage, page$$, options));
      app.contentDOM.dataset.appPdfjsVersion = "0.1.0-beta.1";
      app.scaleDocsToFit = scaleDocsToFit;
      app.syncPDFView = syncPDFView;
      app.log = log;
      if (context.isAddApp)
        app.ready.then(() => {
          const pagesLength = app.numPages();
          const room = context.getRoom();
          if (room && room.isWritable) {
            const scenes = room.entireScenes()[scenePath];
            if (scenes.length < pagesLength) {
              room.putScenes(scenePath, Array.from({ length: pagesLength }, (_, index) => ({ name: String(index + 1) })));
            }
          }
        });
      app.ready.then(() => {
        syncPage(page$$.state.index);
        dispose2.add(page$$.addStateChangedListener(() => syncPage(page$$.state.index)));
        dispose2.add(view$$.addStateChangedListener(() => syncViewFromRemote(false, true)));
      });
      context.mountView(app.whiteboardDOM);
      if (options.disableCameraTransform) {
        view.disableCameraTransform = true;
      }
      dispose2.make(() => {
        view.callbacks.on("onSizeUpdated", scaleDocsToFit);
        return () => view.callbacks.off("onSizeUpdated", scaleDocsToFit);
      });
      dispose2.make(() => {
        view.callbacks.on("onCameraUpdatedByDevice", syncView);
        return () => view.callbacks.off("onCameraUpdatedByDevice", syncView);
      });
      syncViewFromRemote(true);
      dispose2.add(context.emitter.on("writableChange", (isWritable) => {
        app.setReadonly(!isWritable);
        view.disableCameraTransform = !(isWritable && !options.disableCameraTransform);
      }));
      context.emitter.on("destroy", () => dispose2());
      return app;
    }
  };
  var install = (register, options = {}) => {
    let app = NetlessAppPDFjs;
    if (options.as) {
      app = Object.assign({}, app, { kind: options.as });
    }
    return register({ kind: app.kind, src: app, appOptions: options.appOptions });
  };

  // src/index.ts
  var version = "0.1.0-beta.1";

  exports.AppPDFViewer = AppPDFViewer;
  exports.NetlessAppPDFjs = NetlessAppPDFjs;
  exports.PDFViewer = PDFViewer;
  exports.default = NetlessAppPDFjs;
  exports.install = install;
  exports.styles = style_default;
  exports.version = version;

  Object.defineProperty(exports, '__esModule', { value: true });

  return exports;

})({});
